// Package auditingapi provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.10.1 DO NOT EDIT.
package auditingapi

import (
	externalRef0 "oransc.org/nonrtric/capifcore/internal/common29122"
	externalRef1 "oransc.org/nonrtric/capifcore/internal/common29571"
	externalRef2 "oransc.org/nonrtric/capifcore/internal/publishserviceapi"
)

// GetApiInvocationLogsParams defines parameters for GetApiInvocationLogs.
type GetApiInvocationLogsParams struct {
	// String identifying the API exposing function.
	AefId *string `json:"aef-id,omitempty"`

	// String identifying the API invoker which invoked the service API.
	ApiInvokerId *string `json:"api-invoker-id,omitempty"`

	// Start time of the invocation time range.
	TimeRangeStart *externalRef0.DateTime `json:"time-range-start,omitempty"`

	// End time of the invocation time range.
	TimeRangeEnd *externalRef0.DateTime `json:"time-range-end,omitempty"`

	// String identifying the API invoked.
	ApiId *string `json:"api-id,omitempty"`

	// API name, it is set as {apiName} part of the URI structure as defined in clause 5.2.4 of 3GPP TS 29.122.
	ApiName *string `json:"api-name,omitempty"`

	// Version of the API which was invoked.
	ApiVersion *string `json:"api-version,omitempty"`

	// Protocol invoked.
	Protocol *externalRef2.Protocol `json:"protocol,omitempty"`

	// Operation that was invoked on the API.
	Operation *externalRef2.Operation `json:"operation,omitempty"`

	// Result or output of the invocation.
	Result *string `json:"result,omitempty"`

	// Name of the specific resource invoked.
	ResourceName *string `json:"resource-name,omitempty"`

	// Interface description of the API invoker.
	SrcInterface *externalRef2.InterfaceDescription `json:"src-interface,omitempty"`

	// Interface description of the API invoked.
	DestInterface *externalRef2.InterfaceDescription `json:"dest-interface,omitempty"`

	// To filter irrelevant responses related to unsupported features
	SupportedFeatures *externalRef1.SupportedFeatures `json:"supported-features,omitempty"`
}
