// Package routinginfoapi provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.10.1 DO NOT EDIT.
package routinginfoapi

import (
	externalRef0 "oransc.org/nonrtric/capifcore/internal/common"
	externalRef1 "oransc.org/nonrtric/capifcore/internal/common29122"
	externalRef2 "oransc.org/nonrtric/capifcore/internal/common29571"
	externalRef3 "oransc.org/nonrtric/capifcore/internal/publishserviceapi"
)

// Represents IPv6 address range.
type Ipv6AddressRange struct {
	// string identifying a Ipv6 address formatted according to clause 4 in IETF RFC 5952. The mixed Ipv4 Ipv6 notation according to clause 5 of IETF RFC 5952 shall not be used.
	End externalRef1.Ipv6Addr `json:"end"`

	// string identifying a Ipv6 address formatted according to clause 4 in IETF RFC 5952. The mixed Ipv4 Ipv6 notation according to clause 5 of IETF RFC 5952 shall not be used.
	Start externalRef1.Ipv6Addr `json:"start"`
}

// Represents an API routing information.
type RoutingInfo struct {
	RoutingRules []RoutingRule `json:"routingRules"`
}

// Represents an API routing rule.
type RoutingRule struct {
	// Represents the AEF profile data.
	AefProfile     externalRef3.AefProfile          `json:"aefProfile"`
	Ipv4AddrRanges *[]externalRef0.Ipv4AddressRange `json:"ipv4AddrRanges,omitempty"`
	Ipv6AddrRanges *[]Ipv6AddressRange              `json:"ipv6AddrRanges,omitempty"`
}

// GetServiceApisServiceApiIdParams defines parameters for GetServiceApisServiceApiId.
type GetServiceApisServiceApiIdParams struct {
	// Identifier of the AEF
	AefId string `json:"aef-id"`

	// To filter irrelevant responses related to unsupported features
	SuppFeat *externalRef2.SupportedFeatures `json:"supp-feat,omitempty"`
}
